<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">

    <a-spin :spinning="confirmLoading">
      <a-form :form="form">

        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="职务编码">
          <a-input :maxLength="10" placeholder="请输入职位编码" v-decorator="['code', validatorRules.code]" :read-only="readOnly"/>
        </a-form-item>
        <a-form-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          label="职务名称">
          <a-input :maxLength="15" placeholder="请输入职位名称" v-decorator="['name', validatorRules.name]"/>
        </a-form-item>
      
        <a-form-item label="部门" :labelCol="labelCol" :wrapperCol="wrapperCol" >
          <a-input-search placeholder="点击选择部门" v-decorator="['deptName',validatorRules.deptname]"  @search="onSearch">
            <a-button slot="enterButton" icon="search">选择</a-button>
          </a-input-search>
        </a-form-item>
        
      </a-form>
      <depart-window ref="departWindow" @ok="modalFormOk"></depart-window>
    </a-spin>
  </a-modal>
  
</template>

<script>
  import pick from 'lodash.pick'
  import { httpAction } from '@/api/manage'
  import { duplicateCheck } from '@/api/api'
  import JDictSelectTag from '@/components/dict/JDictSelectTag'
  import departWindow from './DepartWindow'
import { queryIdTree } from '@/api/api'
  let validatorCodeTimer = null

  export default {
    name: 'SysPositionModal',
    components: { 
    JDictSelectTag,
    departWindow
    },
    data() {
      return {
        departTree:[],
        checkedDepartKeys:[],
        selectDeptKeys:[],
        visibles:false,
        title: '操作',
        visible: false,
        deptname:"",
        deptid:"",
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        form: this.$form.createForm(this),
        validatorRules: {
          code: {
            rules: [
              { required: true, message: '请输入职位编码' },
              {
                validator: (rule, value, callback) => {
                  // 函数消抖的简单实现，防止一段时间内发送多次请求
                  if (validatorCodeTimer) {
                    // 停止上次开启的定时器
                    clearTimeout(validatorCodeTimer)
                  }
                  validatorCodeTimer = setTimeout(() => {
                    duplicateCheck({
                      tableName: 'sys_position',
                      fieldName: 'code',
                      fieldVal: value,
                      dataId: this.model.id
                    }).then((res) => {
                      if (res.success) {
                        callback()
                      } else {
                        callback(res.message)
                      }
                    }).catch(console.error)
                  }, 300)
                }
              }
            ]
          },
          name: { rules: [{ required: true, message: '请输入职位名称' }] },
          deptname: { rules: [{ required: true, message: '请选择部门' }] },
        },
        url: {
          add: '/sys/position/add',
          edit: '/sys/position/edit',
        },
        readOnly:false
      }
    },
    created() {
      
    },
    methods: {
      add() {
        this.edit({})
      },
      edit(record) {
        this.selectDeptKeys=[];
        this.form.resetFields()
        console.log(record)
        this.model = Object.assign({}, record)
        this.visible = true
        if(record.id){
          this.readOnly=true
        }else{
          this.readOnly=false
        }
        this.deptid=record.deptId;
        this.selectDeptKeys.push(record.deptId);
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,
            'code',
            'name',
            'postRank',
            'deptName'
          ))
        })
      },
      close() {
        this.$emit('close')
        this.visible = false
      },
      handleOk() {
        const that = this
        // 触发表单验证
        // if(this.model.deptId==null||this.model.deptId==""){
        //   that.$message.warning("请选择部门！");
        //   return;
        // }
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true
            let httpurl = ''
            let method = ''
            if (!this.model.id) {
              httpurl += this.url.add
              method = 'post'
            } else {
              httpurl += this.url.edit
              method = 'put'
            }

            let formData = Object.assign(this.model, values)
            formData.deptId=this.deptid;
            httpAction(httpurl, formData, method).then((res) => {
              if (res.success) {
                that.$message.success(res.message)
                that.$emit('ok')
              } else {
                that.$message.warning(res.message)
              }
            }).finally(() => {
              that.confirmLoading = false
              that.close()
            })
          }
        })
      },
      handleCancel() {
        this.close()
      },
// 搜索用户对应的部门API
      onSearch() {
        this.$refs.departWindow.add(this.selectDeptKeys, "");
      },
 // 获取用户对应部门弹出框提交给返回的数据
      modalFormOk(formData) {
        this.form.setFieldsValue({
          deptName:formData.departIdList[0].title
        })
       this.deptid=formData.departIdList[0].value;
        this.selectDeptKeys.push(formData.departIdList[0].value)
      },
    }
  }
</script>

<style lang="less" scoped>

</style>
